-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_ManipulateBones"

-- **************************************************
-- General information about this script
-- **************************************************

DS_ManipulateBones = {}


function DS_ManipulateBones:Name()
	return "Manipulate Bones"
end

function DS_ManipulateBones:Version()
	return "1.1"
end

function DS_ManipulateBones:Description()
	return "Manipulate bones. Hold SHIFT to scale, CTRL to rotate a single bone or ALT to translate bone."
end

function DS_ManipulateBones:Creator()
	return "dauid.com"
end

function DS_ManipulateBones:UILabel()
	return "Manipulate Bones"
end

-- **************************************************
-- Recurring values
-- **************************************************

DS_ManipulateBones.selID = -1
DS_ManipulateBones.lastVec = LM.Vector2:new_local()
DS_ManipulateBones.keyEveryMode = false
LM_ManipulateBones.selID = -1
DS_ManipulateBones.oldAngle = 0
DS_ManipulateBones.newAngle = 0
DS_ManipulateBones.difference = 0
DS_ManipulateBones.oldPos = LM.Vector2:new_local()
DS_ManipulateBones.newPos = LM.Vector2:new_local()
DS_ManipulateBones.posDifference = LM.Vector2:new_local()
DS_ManipulateBones.oldScale = 0
DS_ManipulateBones.newScale = 0
DS_ManipulateBones.scaleDifference = 0
DS_ManipulateBones.theBone = nil
DS_ManipulateBones.allKeysMode = false
DS_ManipulateBones.allKeysModeSetting = 0 -- 0 is rotation, 1 is position, 2 is scale
DS_ManipulateBones.pickchar = false
-- **************************************************
-- The guts of this script
-- **************************************************


function DS_ManipulateBones:OnMouseDown(moho, mouseEvent, keyEvent)
if DS_ManipulateBones.pickchar == true then
		local layer = mouseEvent.view:PickGlobalLayer(mouseEvent.pt)
		if layer ~= nil then
				moho:SetSelLayer(layer:Parent()) 
				moho:UpdateUI()
				DS_ManipulateBones.pickchar = false
				return
		end
end




	local skel = moho:Skeleton()
	if (skel == nil) then
		return
	end
	--[[
	if (DS_ManipulateBones.allKeysMode == true) then
	print("True")
	elseif (DS_ManipulateBones.allKeysMode == false) then
	print("False")
	end
	
	if (DS_ManipulateBones.keyEveryMode == true) then
	print("Key every True")
	elseif (DS_ManipulateBones.keyEveryMode == false) then
	print("Key every False")
	end
	]]--


	
	if mouseEvent.shiftKey then
		LM_ScaleBone:OnMouseDown(moho, mouseEvent)
		self.allKeysModeSetting = 2
	elseif mouseEvent.altKey then
		LM_TranslateBone:OnMouseDown(moho, mouseEvent)
		self.allKeysModeSetting = 1
	elseif mouseEvent.ctrlKey  or self.allKeysMode then
		LM_RotateBone:OnMouseDown(moho, mouseEvent)
		self.allKeysModeSetting = 0
	else
	LM_ManipulateBones:OnMouseDown(moho, mouseEvent)
	self.allKeysModeSetting = 0
	end
	
		if (self.allKeysMode) then
		for i = 0, skel:CountBones() - 1 do
			local bone = skel:Bone(i)
			if (bone.fSelected) then
			self.theBone=i
			--print(i)
				if (self.allKeysModeSetting == 0) then
				self.oldAngle=bone.fAnimAngle:GetValue(moho.layerFrame)
				elseif (self.allKeysModeSetting == 1) then
				self.oldPos=bone.fAnimPos:GetValue(moho.layerFrame)
				elseif (self.allKeysModeSetting == 2) then
				self.oldScale=bone.fAnimScale:GetValue(moho.layerFrame)
				end
			end
		end
	end
	
end

function DS_ManipulateBones:OnMouseMoved(moho, mouseEvent)
	local skel = moho:Skeleton()
	if (skel == nil) then
		return
	end


	
	if mouseEvent.shiftKey then
		LM_ScaleBone:OnMouseMoved(moho, mouseEvent)
		return
	elseif mouseEvent.altKey then
		LM_TranslateBone:OnMouseMoved(moho, mouseEvent)
		return
	elseif mouseEvent.ctrlKey or self.allKeysMode then
		LM_RotateBone:OnMouseMoved(moho, mouseEvent)
		return
	else
	LM_ManipulateBones:OnMouseMoved(moho, mouseEvent)
		return
	end
end

function DS_ManipulateBones:OnMouseUp(moho, mouseEvent)
	local skel = moho:Skeleton()
	if (skel == nil) then
		return
	end
	
	

	if (self.keyEveryMode) then
	DS_ManipulateBones:keyEveryBone(moho)
	end
	
	if mouseEvent.shiftKey then
		LM_ScaleBone:OnMouseUp(moho, mouseEvent)
	elseif mouseEvent.altKey then
		LM_TranslateBone:OnMouseUp(moho, mouseEvent)
	elseif mouseEvent.ctrlKey then
		LM_RotateBone:OnMouseUp(moho, mouseEvent)
	else
		LM_ManipulateBones:OnMouseUp(moho, mouseEvent)
	end	
	if (self.allKeysMode) then
		if (self.allKeysModeSetting == 0) then
			self.newAngle=skel:Bone(self.theBone).fAnimAngle:GetValue(moho.layerFrame)---------------------------------------------------------------
			self.difference = self.newAngle - self.oldAngle
			self:RotateAllKeys(moho)
		elseif (self.allKeysModeSetting == 1) then
			self.newPos=skel:Bone(self.theBone).fAnimPos:GetValue(moho.layerFrame)---------------------------------------------------------------
			self.posDifference = self.newPos - self.oldPos
			self:PositionAllKeys(moho)
		elseif (self.allKeysModeSetting == 2) then
			self.newScale=skel:Bone(self.theBone).fAnimScale:GetValue(moho.layerFrame)---------------------------------------------------------------
			self.scaleDifference = self.newScale - self.oldScale
			self:ScaleAllKeys(moho)
		end
	end
end

function DS_ManipulateBones:RotateAllKeys(moho)
local skel = moho:Skeleton()
	if (skel == nil) then
		return
	end
local bone = skel:Bone(self.theBone)
local duration = bone.fAnimAngle:Duration()
local currFrame = moho.frame

	for i = 1, duration  do
		if (bone.fAnimAngle:HasKey(i) and i ~= currFrame) or (i == 1 and i ~= currFrame) then
			local currValue = bone.fAnimAngle:GetValue(i)
			bone.fAnimAngle:SetValue(i, currValue + self.difference)
		end
	end
	moho:UpdateSelectedChannels()
end

function DS_ManipulateBones:PositionAllKeys(moho)
local skel = moho:Skeleton()
	if (skel == nil) then
		return
	end
local bone = skel:Bone(self.theBone)
local duration = bone.fAnimPos:Duration()
local currFrame = moho.frame

	for i = 1, duration  do
		if (bone.fAnimPos:HasKey(i) and i ~= currFrame) or (i == 1 and i ~= currFrame) then
			local currValue = bone.fAnimPos:GetValue(i)
			bone.fAnimPos:SetValue(i, currValue + self.posDifference)
		end
	end
	moho:UpdateSelectedChannels()
end

function DS_ManipulateBones:ScaleAllKeys(moho)
local skel = moho:Skeleton()
	if (skel == nil) then
		return
	end
	
local bone = skel:Bone(self.theBone)
local duration = bone.fAnimScale:Duration()
local currFrame = moho.frame

	for i = 1, duration  do
		if (bone.fAnimScale:HasKey(i) and i ~= currFrame)  or (i == 1 and i ~= currFrame)  then
			local currValue = bone.fAnimScale:GetValue(i)
			bone.fAnimScale:SetValue(i, currValue + self.scaleDifference)
		end
	end
	moho:UpdateSelectedChannels()
end

function DS_ManipulateBones:keyEveryBone(moho)
local skel = moho:Skeleton()
	if (skel == nil) then
		return
	end
	for i = 0, skel:CountBones() - 1 do
			local bone = skel:Bone(i)
			bone.fAnimPos:AddKey( moho.frame )
			moho:NewKeyframe(CHANNEL_BONE_T)
			bone.fAnimAngle:AddKey( moho.frame )
			moho:NewKeyframe(CHANNEL_BONE)
			bone.fAnimScale:AddKey( moho.frame )
			moho:NewKeyframe(CHANNEL_BONE_S)
			moho.layer:UpdateCurFrame()
			moho:UpdateBonePointSelection()	
		end
end

function DS_ManipulateBones:LockTheBone(moho)
local skel = moho:Skeleton()
	if (skel == nil) then
			return
	end

		if (moho:CountSelectedBones() > 0) then
			moho.document:PrepUndo(moho.layer)
			moho.document:SetDirty()
			for i = 0, skel:CountBones() - 1 do
				local bone = skel:Bone(i)
				if (bone.fSelected) then
					if (self.lockBone:Value()) then
						skel:LockBone(i, moho.layerFrame)
					else
						skel:UnlockBone(i, moho.layerFrame)
					end
				end
			end
			moho.layer:UpdateCurFrame(true)
			moho:NewKeyframe(CHANNEL_BONE)
			moho:NewKeyframe(CHANNEL_BONE_LOCK)
		end
end

function DS_ManipulateBones:HideSelected(moho)
local document = moho.document 
	for i = 0, document:CountSelectedLayers()-1 do 
		local layer = document:GetSelectedLayer(i) 
		layer:SetRenderOnly(true)
	end
end

function DS_ManipulateBones:UnhideSelected(moho)
	local document = moho.document 
	local numlayers = document:CountLayers()
	for i = 0, numlayers - 1 do
	local layer = document:Layer(i) 
	--for i = 0, document:CountSelectedLayers()-1 do 
		--local layer = document:GetSelectedLayer(i) 
		layer:SetRenderOnly(false)
	end
end


function DS_ManipulateBones:OnKeyDown(moho, keyEvent)
	
	if (keyEvent.key == 'c') then
	local skel = moho:Skeleton()
		if (skel == nil) then
				return
		end
			for i = 0, skel:CountBones() - 1 do
				local bone = skel:Bone(i)
				bone.fAnimPos:AddKey( moho.frame )
				moho:NewKeyframe(CHANNEL_BONE_T)
				bone.fAnimAngle:AddKey( moho.frame )
				moho:NewKeyframe(CHANNEL_BONE)
				bone.fAnimScale:AddKey( moho.frame )
				moho:NewKeyframe(CHANNEL_BONE_S)
			end
		moho.layer:UpdateCurFrame()
		moho:UpdateBonePointSelection()	
	end
	if (keyEvent.key == 'l') then
		self:LockTheBone(moho)
	end
	
	if (keyEvent.key == ',') then
		self:HideSelected(moho)
	end
	
	if (keyEvent.key == '.') then
		self:UnhideSelected(moho)
	end
	if (keyEvent.key == 'v') then
	DS_ManipulateBones.pickchar = true
	end
end

---------------------------------------------------------------------

-- **************************************************
-- Tool options - create and respond to tool's UI
-- **************************************************


DS_ManipulateBones.FREEZE = MOHO.MSG_BASE
DS_ManipulateBones.TRANSLATION = MOHO.MSG_BASE+1
DS_ManipulateBones.SCALE = MOHO.MSG_BASE +2
DS_ManipulateBones.ROTATION = MOHO.MSG_BASE +3
DS_ManipulateBones.LOCK = MOHO.MSG_BASE +4
DS_ManipulateBones.RESET = MOHO.MSG_BASE +5
DS_ManipulateBones.KEYALL = MOHO.MSG_BASE +6
DS_ManipulateBones.KEYEVERY = MOHO.MSG_BASE +7
DS_ManipulateBones.KEYROT = MOHO.MSG_BASE +8
DS_ManipulateBones.ALLKEYS = MOHO.MSG_BASE +9

function DS_ManipulateBones:DoLayout(moho, layout)
	layout:AddChild(LM.GUI.Button("Freeze", self.FREEZE))
	layout:AddChild(LM.GUI.Button("Key all", self.KEYALL))
	layout:AddChild(LM.GUI.Button("Key rotation", self.KEYROT))
	layout:AddChild(LM.GUI.Divider(true))
	
	layout:AddChild(LM.GUI.Button("Reset all", self.RESET))
	layout:AddChild(LM.GUI.StaticText("Reset selected:"))
	layout:AddChild(LM.GUI.Button("Position", self.TRANSLATION))
	layout:AddChild(LM.GUI.Button("Scale", self.SCALE))
	layout:AddChild(LM.GUI.Button("Rotation", self.ROTATION))
	self.lockBone = LM.GUI.CheckBox("Lock bone", self.LOCK)
	layout:AddChild(LM.GUI.Divider(true))
	layout:AddChild(self.lockBone)
	layout:AddChild(LM.GUI.Divider(true))
	self.keyEvery = LM.GUI.CheckBox("Key all with every edit", self.KEYEVERY)
	layout:AddChild(self.keyEvery)
	self.keyEvery:SetValue(self.keyEveryMode)
	
	layout:AddChild(LM.GUI.Divider(true))
	self.allKeys = LM.GUI.CheckBox("Change all keys", self.ALLKEYS)
	layout:AddChild(self.allKeys)
	self.allKeys:SetValue(self.allKeysMode)
	
	

end

function DS_ManipulateBones:UpdateWidgets(moho)
	local skel = moho:Skeleton()
	if (skel == nil) then
			return
	end
	
	self.keyEvery:SetValue(DS_ManipulateBones.keyEveryMode)
	self.allKeys:SetValue(DS_ManipulateBones.allKeysMode)
	
	for i = 0, skel:CountBones() - 1 do
			local bone = skel:Bone(i)
			if (bone.fSelected) then
				self.lockBone:SetValue(bone.fIKLock.value)
			end
	end
end


function DS_ManipulateBones:HandleMessage(moho, view, msg)
	local skel = moho:Skeleton()
	if (skel == nil) then
		return
	end
	
	moho.document:PrepUndo(moho.layer)
	moho.document:SetDirty()
------------------------------------------------------------------Freeze pose clicked
	if (msg == self.FREEZE) then
		for i = 0, skel:CountBones() - 1 do
			local bone = skel:Bone(i)
			if (bone.fAnimPos:CountKeys()>1) then
			bone.fAnimPos:AddKey( moho.frame )
			moho:NewKeyframe(CHANNEL_BONE_T)
			end
			if (bone.fAnimAngle:CountKeys()>1) then
			bone.fAnimAngle:AddKey( moho.frame )
			moho:NewKeyframe(CHANNEL_BONE)
			end
			if (bone.fAnimScale:CountKeys()>1) then
			bone.fAnimScale:AddKey( moho.frame )
			moho:NewKeyframe(CHANNEL_BONE_S)
			end
			moho.layer:UpdateCurFrame()
			moho:UpdateBonePointSelection()
			
			
			
		end
	end
	------------------------------------------------------------------Key all clicked
	if (msg == self.KEYALL) then
		for i = 0, skel:CountBones() - 1 do
			local bone = skel:Bone(i)
			bone.fAnimPos:AddKey( moho.frame )
			moho:NewKeyframe(CHANNEL_BONE_T)
			bone.fAnimAngle:AddKey( moho.frame )
			moho:NewKeyframe(CHANNEL_BONE)
			bone.fAnimScale:AddKey( moho.frame )
			moho:NewKeyframe(CHANNEL_BONE_S)
			moho.layer:UpdateCurFrame()
			moho:UpdateBonePointSelection()	
		end
	end
		------------------------------------------------------------------Key all rotation
	if (msg == self.KEYROT) then
		for i = 0, skel:CountBones() - 1 do
			local bone = skel:Bone(i)
			bone.fAnimAngle:AddKey( moho.frame )
			moho:NewKeyframe(CHANNEL_BONE)
			moho.layer:UpdateCurFrame()
			moho:UpdateBonePointSelection()	
		end
	end
------------------------------------------------------------------Reset rotation clicked
	if (msg == self.ROTATION) then
		if (moho:CountSelectedBones() > 0) then
			moho.document:PrepUndo(moho.layer)
			moho.document:SetDirty()
			for i = 0, skel:CountBones() - 1 do
				local bone = skel:Bone(i)
				if (bone.fSelected) then
					bone.fAnimAngle:SetValue(moho.layerFrame, bone.fAnimAngle:GetValue(0))
				end
			end
			moho.layer:UpdateCurFrame()
			moho:NewKeyframe(CHANNEL_BONE)
		end
	end
------------------------------------------------------------------Reset scale clicked
	if (msg == self.SCALE) then
		if (moho:CountSelectedBones() > 0) then
			moho.document:PrepUndo(moho.layer)
			moho.document:SetDirty()
			for i = 0, skel:CountBones() - 1 do
				local bone = skel:Bone(i)
				if (bone.fSelected) then
					bone.fAnimScale:SetValue(moho.layerFrame, bone.fAnimScale:GetValue(0))
				end
			end
			moho.layer:UpdateCurFrame()
			moho:NewKeyframe(CHANNEL_BONE_S)

		end
	end
------------------------------------------------------------------Reset translation clicked
	if (msg == self.TRANSLATION) then
		for i = 0, skel:CountBones() - 1 do
			local bone = skel:Bone(i)
			if (bone.fSelected) then
				moho.document:PrepUndo(moho.layer)
				moho.document:SetDirty()
				bone.fAnimPos:SetValue(moho.layerFrame, bone.fAnimPos:GetValue(0))
				moho.layer:UpdateCurFrame()
				moho:NewKeyframe(CHANNEL_BONE_T)
				break
			end
		end
	end
------------------------------------------------------------------Lock bone clicked
	if (msg == self.LOCK) then	
		self:LockTheBone(moho)
	end
------------------------------------------------------------------Reset all clicked
	if (msg == self.RESET) then
		for i = 0, skel:CountBones() - 1 do
			local bone = skel:Bone(i)
			
			if (bone.fAnimPos:CountKeys()>1) then
			bone.fAnimPos:SetValue(moho.layerFrame, bone.fAnimPos:GetValue(0))
			moho:NewKeyframe(CHANNEL_BONE_T)
			end
			if (bone.fAnimAngle:CountKeys()>1) then
			bone.fAnimAngle:SetValue(moho.layerFrame, bone.fAnimAngle:GetValue(0))
			moho:NewKeyframe(CHANNEL_BONE)
			end
			if (bone.fAnimScale:CountKeys()>1) then
			bone.fAnimScale:SetValue(moho.layerFrame, bone.fAnimScale:GetValue(0))
			moho:NewKeyframe(CHANNEL_BONE_S)
			end
			moho.layer:UpdateCurFrame()
		
		end
	end
------------------------------------------------------------------Key every mode
	if (msg == self.KEYEVERY) then
		self.keyEveryMode=self.keyEvery:Value()	
	end
	------------------------------------------------------------------Change all keys
	if (msg == self.ALLKEYS) then
		self.allKeysMode=self.allKeys:Value()	
	end

end
